//SQ7515_SIO_Master_For_SPI_Flash_IS25LP080D
//*************************************************************************************
// 	: main.c
// 汾		: V1.1 2022/07/12
// 		: 
// ˵	: ΪSQ7515 SIO1Master,SPI Flash IS25LP080DͨѶ
//			  IDE趨ϵ㣬ͨѶSector д롢ȡ֮
// ע		: ֮ӦѹΪ3.3VóSPI Flash IS25LP080D֮ѹջ
//            * ʹ÷MQ-Link磬ȷϵѹΪ"3.3V"Ϊ5V
//
// MSB ( bit7 ʼ),ѡ SIO ģʽ8 λͼģʽ,CPOL = 1, CPHA=1
// ע		: 1. SIO1(ΪMaster) 
//			         (P0.2)ΪSCLK1
//		             (P0.0)ΪSI1
//					 (P0.1)ΪSO1
// 
//			  2. (P0.2)SCLK1----ӵ----IS25LP080D SCK0 ;    SCK
//				 (P0.0)SI1  ----ӵ----IS25LP080D SO   ;    MISO
//				 (P0.1)SO1  ----ӵ----IS25LP080D SI   ;    MOSI
//				 (P4.3)/CS  ----ӵ----IS25LP080D CE#  ;    /CSChip EN
//
// 				 (P4.3)/CS ģ⾧ƬPINslave ֻ /CS źΪ͵λʱ, Ŷ master ĲָзӦ[ҪʹLA SPI¼ƴ֮ʱ]
// 
//			  3. 
//				  [LED] LED 1  (P2.0) ȡManufacturerID & DeviceID ȷбƺ
//				  [LED] LED 2  (P2.1) Sector Erase ʱʹLED2һ
//				  [LED] LED 3  (P2.2) Page Program ʱLED3һ
//
//            4.  ȶԶֵȷLEDƵ
//                Data0~7ԶȡȷLED1~3
//                Data0~7жȡLED1~3 
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"
/* ------------------------  ---------------------------- */
#define IS25LP080D_MID  0x9D
#define IS25LP080D_DID  0x13

#define AT25FF041A_MID  0x1F
#define AT25FF041A_DID  0x44

/* ----------------------  -------------------------- */

unsigned char m_rx;
unsigned char Read_Data[16];
unsigned char Send_Data[4];

unsigned char i,j;
unsigned char ManufacturerID_DATA = 0,DeviceID_DATA = 0;
/* -------------------- ԭ ------------------------ */
void Dummy_Delay(void);

/* -----------------------  --------------------------- */
void main()
{
/* ---------------------- ϵͳʼ ------------------------ */
	CLKCR1_HIRCEN  = 1;                 //  HIRC
	while(CLKCR1_HIRCRDY ==0);          // ȴ HIRC 
	CLKCR0_SCKPSC = 0x00;               // ϵͳƵʳ1   (16M/1=16MHz) 
 	CLKCR0_SCKSRC = 0;                  // ʱԴлHIRC
	while(CLKCR0_SCKRDY ==0);           // ȴ ϵͳʱ     
    
/* ---------------------- ܽųʼ ------------------------ */
    P0PU = 0xFF;                        // .
    P1PU = 0xFF;
    P2PU = 0xFF;
    P3PU = 0xFF;
    P4PU = 0xFF;
    P5PU = 0xFF;

    P2OE_P0 = 1;                        // 趨P2.0 ܽΪ
    P2PU_P0 = 0;                        // 趨P2.0 .

    P3OE_P7 = 1;                        // 趨P3.7 ܽΪ
    P3PU_P7 = 0;                        // 趨P3.7 .

    P3OE_P6 = 1;                        // 趨P3.6 ܽΪ
    P3PU_P6 = 0;                        // 趨P3.6 .

    P4OE_P3 = 1;                        // 趨P2.4 ܽΪ
    P4PU_P3 = 0;                        // 趨P2.4 .
    P4DO_P3 = 1;                        // ʼ趨P4.3ܽߵƽ

    LED1_out = 1;                       // ʼ趨LED1Ϊ״̬
    LED2_out = 1;                       // ʼ趨LED2Ϊ״̬
    LED3_out = 1;                       // ʼ趨LED3Ϊ״̬

/* ---------------------- SIO1 ʼ ------------------------ */	
    SIO1_Init();                        // SIO1ʼOMaster
	for(i=0;i<250;i++);                 // Delay loop
	
	
 //	 0x90 Ϊȡ Read Manufacturer ID:and Device ID 0x13 --------------------------------------------
    P4DO_P3 = 0;                        // /CS PIN Enable (͵ƽ)
    for(i=0;i<50;i++);
    SIO_ByteSend(SIO_1,0x90);           // master TX 0x90 
    SIO_ByteSend(SIO_1,0x00);           // 3 Dummy Bytes
    SIO_ByteSend(SIO_1,0x00);                  
    SIO_ByteSend(SIO_1,0x00);
    for(i=0;i<10;i++);                  // Delay loop

    ManufacturerID_DATA = SIO_ByteRead(SIO_1);  // master RX ȡManufacturer ID
    DeviceID_DATA = SIO_ByteRead(SIO_1);        // master RX ȡDevice ID

    P4DO_P3 = 1;                        // /CS PIN Disable (ߵƽ)
	
    // Ԥ ManufacturerID_DATAΪ0x9D  DeviceID_DATA Ϊ0x13
    // ȡȷLED1ȷLED1άֵ
    if(ManufacturerID_DATA == IS25LP080D_MID && DeviceID_DATA == IS25LP080D_DID ){    
        LED1_out = 0;                   // ȷLED1
    }
    else{
        LED1_out = 1;                   // LED1
    }

    __asm("NOP");                       // **ָϵ㴦ڴ˴**

 // *** ִ Sector Erase֮ǰִWrite Enable *** //
 //	 0x06 ΪWrite Enable: ------------------------------------------------
 	P4DO_P3 = 0;                        // /CS PIN Enable (͵ƽ)
 	SIO_ByteSend(SIO_1,0x06);           // master TX 0x06 
    P4DO_P3 = 1;                        // /CS PIN Disable (ߵƽ)  
	
	for(i=0;i<250;i++);
    
 //	 0x20 ΪSector Erase 4K-bytes ----------------------------------------
    
	P4DO_P3 = 0;                              // /CS PIN Enable (͵ƽ)
	SIO_ByteSend(SIO_1,0x20);                 // master TX 0x20 
	
    // Sector Erase [Sector 48] ʼλַΪ: 030000h
    SIO_ByteSend(SIO_1,0x03);                 // ADDR msb   A23 ~A16
    SIO_ByteSend(SIO_1,0x00);                 // ADDR       A15 ~A8 
    SIO_ByteSend(SIO_1,0x00);	              // ADDR lsb   A7  ~A0
    P4DO_P3 = 1;                              // /CS PIN Disable (ߵƽ)
    for(i=0;i<250;i++);
    for(i=0;i<250;i++);
    IS25LP_WaitBusy();
    // Sector Erase Time (4K-bytes) wait>300 ms
    // Delay loop
    for(i=0;i<250;i++);                       // Delay loop
    for(i=0;i<250;i++);                       // Delay loop
    for(i=0;i<250;i++);                       // Delay loop

    LED2_out = 0;                             // LED2
    Dummy_Delay();
    LED2_out = 1;                             // LED2
	
    __asm("NOP");	                          // **ָϵ㴦ڴ˴**
 // -------------------------------------------------------------------------------
 //	 0x03 Ϊȡ Slave Data: ------------------------------------------------
 // ոSector Erase 4K-bytesڶȡSlave Data 
 
    P4DO_P3 = 0;                              // /CS PIN Enable (͵ƽ)
	SIO_ByteSend(SIO_1,0x03);                 // master TX 0x03 
	// [Sector 48] ʼλַΪ: 030000h
	SIO_ByteSend(SIO_1,0x03);                 // ADDR msb   A23 ~A16
	SIO_ByteSend(SIO_1,0x00);                 // ADDR       A15 ~A8
	SIO_ByteSend(SIO_1,0x00);                 // ADDR lsb   A7  ~A0

    for(i=0;i<16;i++){
        Read_Data[i] = SIO_ByteRead(SIO_1);	      // SIO1
    }

    P4DO_P3 = 1;                              // /CS PIN Disable (ߵƽ)
	
    __asm("NOP");	                          // **ָϵ㴦ڴ˴**


 // *** ִ Page Program֮ǰִWrite Enable *** //
 //	 0x06 ΪWrite Enable: ------------------------------------------------  
 	P4DO_P3 = 0;                        // /CS PIN Enable (͵ƽ)
 	SIO_ByteSend(SIO_1,0x06);           // master TX 0x06 
    P4DO_P3 = 1;                        // /CS PIN Disable (ߵƽ) 
 
	for(i=0;i<250;i++);                 // Delay loop
    
 //	 0x02 Ϊд Slave Data: ---------------------------------------------
    P4DO_P3 = 0;                        // /CS PIN Enable (͵ƽ)
    SIO_ByteSend(SIO_1,0x02);           // Page Program (PP, 02h)
    // [Sector 48] ʼλַΪ: 030000h
    SIO_ByteSend(SIO_1,0x03);           // ADDR msb   A23 ~A16
    SIO_ByteSend(SIO_1,0x00);           // ADDR       A15 ~A8
    SIO_ByteSend(SIO_1,0x00);           // ADDR lsb   A7  ~A0

    // Program Data0~Data7:0x76,0x15,0x1A,0x2B,0x3C,0x4D,0x5E,0x6F
    SIO_ByteSend(SIO_1,0x76);           // PGM data 0
    SIO_ByteSend(SIO_1,0x15);           // PGM data 1

    SIO_ByteSend(SIO_1,0x1A);           // PGM data 2
    SIO_ByteSend(SIO_1,0x2B);           // PGM data 3

    SIO_ByteSend(SIO_1,0x3C);           // PGM data 4
    SIO_ByteSend(SIO_1,0x4D);           // PGM data 5

    SIO_ByteSend(SIO_1,0x5E);           // PGM data 6
    SIO_ByteSend(SIO_1,0x6F);           // PGM data 7

    for(i=0;i<16;i++){
        Read_Data[i] = SIO_ByteRead(SIO_1);     // SIO1
    }

    P4DO_P3 = 1;                        // /CS PIN Disable (ߵƽ) 
    for(i=0;i<250;i++);                 // Delay loop

    IS25LP_WaitBusy();        

    for(i=0;i<255;i++){                 // Delay loop
        for(j=0;j<255;j++){
        }
    }

    LED3_out = 0;                       // LED3
    Dummy_Delay();
    LED3_out = 1;                       // LED3

    __asm("NOP");                       // **ָϵ㴦ڴ˴**
   

 //	 0x03 Ϊȡ Slave Data: ---------------------------------------------
 // ոPage ProgramڶȡSlave DataǷдSPI Flash
 
    P4DO_P3 = 0;                        // /CS PIN Enable (͵ƽ) 
    SIO_ByteSend(SIO_1,0x03);           // master TX 0x03 
    // [Sector 48] ʼλַΪ: 030000h
    SIO_ByteSend(SIO_1,0x03);           // ADDR msb   A23 ~A16
    SIO_ByteSend(SIO_1,0x00);           // ADDR       A15 ~A8
    SIO_ByteSend(SIO_1,0x00);           // ADDR lsb   A7  ~A0
        
    for(i=0;i<16;i++){
        Read_Data[i] = SIO_ByteRead(SIO_1);     // SIO1
    }

    P4DO_P3 = 1;                        // /CS PIN Disable (ߵƽ) 
	
    // ȶԶֵȷLEDƵ
    if(Read_Data[0] == 0x76 &&
       Read_Data[1] == 0x15 &&
       Read_Data[2] == 0x1A &&
       Read_Data[3] == 0x2B &&
       Read_Data[4] == 0x3C &&
       Read_Data[5] == 0x4D &&
       Read_Data[6] == 0x5E &&
       Read_Data[7] == 0x6F){
        LED_all_turn_on;                // ȷLED1~3
    }
    else{
        LED_all_turn_off;               // LED1~3
    }
    
    __asm("NOP");                       // **ָϵ㴦ڴ˴**


    while(1){
        CLR_WDT;                        // Źʱ (ι) 
    }
}

void Dummy_Delay(void){

    unsigned short i, j;

	for(i=0;i<1000;i++){                       // Delay loop
        for(j=0;j<1000;j++){
            __asm("NOP");
            __asm("NOP");
            __asm("NOP");
            __asm("NOP");
        }
    }

}

/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n OnlyRetn(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n IntWDT(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n IntSWI(void){        // SWIλжϷ
    PRSTR7 = 0x5a;
    PRSTR7 = 0xa5;
    PRSTR7 = 0xc3;
    PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */

/* -------------------- SQ7515ж ------------------ */
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	IntSIO1,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	OnlyReti,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,				/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	OnlyReti,				/* 0xffa2 : IntEXT7			*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEXT6			*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEXT5			*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEXT4			*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEXT3			*/	//ⲿж3								
	OnlyReti,				/* 0xffd2 : IntEXT2			*/	//ⲿж2								
	OnlyReti,				/* 0xffd4 : IntEXT1			*/	//ⲿж1								
	OnlyReti,				/* 0xffd6 : IntEXT0			*/	//ⲿж0								
	OnlyReti,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : IntI2C0			*/	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	OnlyReti,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : IntRTC			*/	//жԴ:ʵʱʱRTCʱ								
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable		
	STARTUP					/* 0xfffe : RESET			*/	//non-maskable			
};
#pragma section const
/* -------------------  SQ7515ж ---------------------- */

