//*************************************************************************************
// 	: SQ7515_UART.c
// 汾		: V1.0 2022/05/18A
// 		: UART ʹú (UARTƳ)
// 
// ע		: UART غ㼯ڱӳ
//			  SQ7515UART0,UART1,UART2 3ʹ;
//			  *ÿһUARTֱжŹѡ
//**************************************************************************************
#include "main.h"
unsigned char RT;
unsigned char DR;
unsigned char rbuf;                         // RX1յֵ(һֽ)ڴ˱
unsigned char RX1_Int_Flag;                 // IntRX1жϷ	
unsigned char rx1_int_count = 0;            // RX1 жϴ(ֽ)

uchar sentBuf[]={0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x76, 0x15, 0x5A, 0xA5};	
uchar reciveBuf[]={0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

//*********************************************************************
// 	: UART0_Init()
// 	: UART0ʼ
// ֵ	: - parityCheck : PARITY_NONE  Уλ
//                          : PARITY_ODD   ͬλУ 
//                          : PARITY_EVEN  żͬλУ  
//
// شֵ	: none
// ע		: 趨żUARTز
//*********************************************************************
void UART0_Init(uchar parityCheck){

  //====== UART0ܽųʼ ======

	
    //--TX0 (P0.1) ; RX0 (P0.0)-------
    FSELR0 = (FSELR0&0xF0)|0x00;        // 趨ѡĴ0Ⱥѡ b00
    PCSELR0_UART0 = 0x00;               // 趨ΧͨѡĴ

    P0FC_P1_TX0;                        // P0.1趨ΪTX0
    P0FC_P0_RX0;                        // P0.0趨ΪRX0
		
    P0PU_P1 = 0;                        // TX0Ƴ
        
  /*	
    //--TX0 (P0.0) ; RX0 (P0.1)-------        
    FSELR0 = (FSELR0&0xF0)|0x01;        // 趨ѡĴ0Ⱥѡ b01
    PCSELR0_UART0 = 0x00;               // 趨ΧͨѡĴ

    P0FC_P0_TX0;                        // P0.0趨ΪTX0
    P0FC_P1_RX0;                        // P0.1趨ΪRX0
        
    P0PU_P0 = 0;                        // TX0Ƴ
  */


  /*
    //--TX0 (P3.7) ; RX0 (P3.6)-------
    FSELR3 = (FSELR3&0x0F)|0x00;        // 趨ѡĴ3Ⱥѡ b00
    PCSELR0_UART0 = 0x01;               // 趨ΧͨѡĴ

    P3FC_P7_TX0;                        // P3.7趨ΪTX0
    P3FC_P6_RX0;                        // P3.6趨ΪRX0
    
    P3PU_P7 = 0;                        // TX0Ƴ
  */


  /*
    //--TX0 (P3.6) ; RX0 (P3.7)-------
    FSELR3 = (FSELR3&0x0F)|0x10;        // 趨ѡĴ3Ⱥѡ b10
    PCSELR0_UART0 = 0x01;               // 趨ΧͨѡĴ
        
    P3FC_P6_TX0;                        // P3.6趨ΪTX0
    P3FC_P7_RX0;                        // P3.7趨ΪRX0
        
    P3PU_P6 = 0;                        // TX0Ƴ
  */	

    //====== ܿ(Enable) ======
    PCKEN1_UART0 = 1;                   // ȿݴò,UART0 Enable

    //====== 趨 ======
    UART0CR1  = (UART0CR1|parityCheck); // żУλO  

    UART0CR1_STOPBT = STOP_1BIT;        // TX0 Ͷ˽λ 1λ
    UART0CR2_STOPBR = STOP_1BIT;        // RX0 ն˽λ 1λ

    // TX0 ѡ
    UART0CR1_IRDASEL = TX_OUTPUT_UART;  // UART 
    //UART0CR1_IRDASEL = TX_OUTPUT_IRDA;  // IrDA 
      
    // շʱѡ
    UART0CR1_BRG = 0;                   // շʱԴϵͳʱ
      
    // Ƶѡ
    UART0CR2_DV = DIV_BY1;              // UART0 Ƶ޳Ƶ

}


//*********************************************************************
// 	: UART1_Init()
// 	: UART1ʼ
// ֵ	: - parityCheck : PARITY_NONE  Уλ
//                          : PARITY_ODD   ͬλУ 
//                          : PARITY_EVEN  żͬλУ  
//
// شֵ	: none
// ע		: 趨żUARTز
//*********************************************************************
void UART1_Init(uchar parityCheck){

  //====== UART1ܽųʼ ======
  
  /*  
    //--TX1 (P2.6) ; RX1 (P2.5)-------
    FSELR2 = (FSELR2&0x0F)|0x00;        // 趨ѡĴ2Ⱥѡ b00    
    PCSELR0_UART1 = 0x00;               // 趨ΧͨѡĴ
        
    P2FC_P6_TX1;                        // P2.6趨ΪTX1
    P2FC_P5_RX1;                        // P2.5趨ΪRX1
        
    P2PU_P6 = 0;                        // TX1Ƴ
  */
	
    //--TX1 (P2.5) ; RX1 (P2.6)-------      [ѡ]    
    FSELR2 = (FSELR2&0x0F)|0x10;        // 趨ѡĴ2Ⱥѡ b10
    PCSELR0_UART1 = 0x00;               // 趨ΧͨѡĴ

    P2FC_P5_TX1;                        // P2.5趨ΪTX1
    P2FC_P6_RX1;                        // P2.6趨ΪRX1

    P2PU_P5 = 0;                        // TX1Ƴ

  /*
    //--TX1 (P5.2) ; RX1 (P5.1)-------
    FSELR5 = (FSELR5&0xF0)|0x00;        // 趨ѡĴ5Ⱥѡ b00    
    PCSELR0_UART1 = 0x01;               // 趨ΧͨѡĴ

    P5FC_P2_TX1;                        // P5.2趨ΪTX1
    P5FC_P1_RX1;                        // P5.1趨ΪRX1
    
    P5PU_P2 = 0;                        // TX1Ƴ
  */


  /* 
    //--TX1 (P5.1) ; RX1 (P5.2)-------
    FSELR5 = (FSELR5&0xF0)|0x01;        // 趨ѡĴ5Ⱥѡ b01
    PCSELR0_UART1 = 0x01;               // 趨ΧͨѡĴ
	
    P5FC_P1_TX1;                        // P5.1趨ΪTX1
    P5FC_P2_RX1;                        // P5.2趨ΪRX1
    
    P5PU_P1 = 0;                        // TX1Ƴ
  */


    //====== ܿ(Enable) ======
    PCKEN1_UART1 = 1;                   // ȿݴò,UART1 Enable

    //====== 趨 ======
    UART1CR1  = (UART1CR1|parityCheck); // żУλO  

	UART1CR1_STOPBT = STOP_1BIT;        // TX1 Ͷ˽λ 1λ
	UART1CR2_STOPBR = STOP_1BIT;        // RX1 ն˽λ 1λ

    // TX1 ѡ
    UART1CR1_IRDASEL = TX_OUTPUT_UART;  // UART 
    //UART1CR1_IRDASEL = TX_OUTPUT_IRDA;  // IrDA 

    // շʱѡ
    UART1CR1_BRG = 0;                   // շʱԴϵͳʱ
 
    // Ƶѡ
    UART1CR2_DV = DIV_BY1;              // UART1 Ƶ޳Ƶ

}


//*********************************************************************
// 	: UART2_Init()
// 	: UART2ʼ
// ֵ	: - parityCheck : PARITY_NONE  Уλ
//                          : PARITY_ODD   ͬλУ 
//                          : PARITY_EVEN  żͬλУ  
//
// شֵ	: none
// ע		: 趨żUARTز
//*********************************************************************
void UART2_Init(uchar parityCheck){

   //====== UART2ܽųʼ ======
	
  /*	
    //--TX2 (P0.5) ; RX2 (P0.4)-------
    FSELR0 = (FSELR0&0x0F)|0x00;        // 趨ѡĴ0Ⱥѡ b00    
    PCSELR0_UART2 = 0x00;               // 趨ΧͨѡĴ

    P0FC_P5_TX2;                        // P0.5趨ΪTX2
    P0FC_P4_RX2;                        // P0.4趨ΪRX2
    
    //P0PU_P4 = 1;                        // RX2
  */	


	
  /*	
    //--TX2 (P0.4) ; RX2 (P0.5)-------
    FSELR0 = (FSELR0&0x0F)|0x10;        // 趨ѡĴ0Ⱥѡ b10
    PCSELR0_UART2 = 0x00;               // 趨ΧͨѡĴ

    P0FC_P4_TX2;                        // P0.4趨ΪTX2
    P0FC_P5_RX2;                        // P0.5趨ΪRX2
        
    //P0PU_P5 = 1;                        // RX2
  */



  /*
    //--TX2 (P3.1) ; RX2 (P3.0)-------
    FSELR3 = (FSELR3&0xF0)|0x00;        // 趨ѡĴ3Ⱥѡ b00    
    PCSELR0_UART2 = 0x01;               // 趨ΧͨѡĴ
    
    P3FC_P1_TX2;                        // P3.1趨ΪTX2
    P3FC_P0_RX2;                        // P3.0趨ΪRX2

    //P3PU_P0 = 1;                        // RX2
  */


  /*
    //--TX2 (P3.0) ; RX2 (P3.1)-------   
    FSELR3 = (FSELR3&0xF0)|0x01;        // 趨ѡĴ3Ⱥѡ b01
    PCSELR0_UART2 = 0x01;               // 趨ΧͨѡĴ
    
    P3FC_P0_TX2;                        // P3.0趨ΪTX2
    P3FC_P1_RX2;                        // P3.1趨ΪRX2

    //P3PU_P1 = 1;                        // RX2
  */

    //====== ܿ(Enable) ======
    PCKEN1_UART2 = 1;                   // ȿݴò,UART2 Enable

    //====== 趨 ======
    UART2CR1  = (UART2CR1|parityCheck); // żУλO  

    UART2CR1_STOPBT = STOP_1BIT;        // TX2 Ͷ˽λ 1λ
    UART2CR2_STOPBR = STOP_1BIT;        // RX2 ն˽λ 1λ

    // TX2 ѡ
    UART2CR1_IRDASEL = TX_OUTPUT_UART;  // UART 
    //UART2CR1_IRDASEL = TX_OUTPUT_IRDA;  // IrDA 
      
    // շʱѡ
    UART2CR1_BRG = 0;                     // շʱԴϵͳʱ
      
    // Ƶѡ
    UART2CR2_DV = DIV_BY1;                // UART2 Ƶ޳Ƶ

}



//*********************************************************************
// 	: UART0_Int()
// 	: UART0ж/ֹ
// ֵ1	: - intEn     : ENABLE  
//                        : DISABLE ֹ
// ֵ2	: - trxSelect : TX
//                        : RX
//                        : TRX
// شֵ	: none
// ע		: ִкῪж(IMF)**
//
// 		: ֻRX0ждUART0_Int(ENABLE, RX);
//          : ֻRX0жϽֹдUART0_Int(DISABLE, RX);
//
//          : TX0RX0жϽдUART0_Int(ENABLE, TRX);
//*********************************************************************
void UART0_Int(uchar intEn, uchar trxSelect){

	__asm("DI");						// ֹпж
    
	switch(trxSelect){
	    case TX:						//  TX0ж/ֹ
            IER_UART0_TX = intEn;       // intEn = ENABLE  ,TX0ж
                                        // intEn = DISABLE ,TX0жϽֹ
        break;
    
    	case RX:						//  RX0ж/ֹ
            IER_UART0_RX = intEn;	    // intEn = ENABLE  ,RX0ж
                                        // intEn = DISABLE ,RX0жϽֹ
        break;

    	case TRX:                       // TX0  RX0ж/ֹ
            IER_UART0_TX = IER_UART0_RX = intEn;
                                        // intEn = ENABLE  ,TX0 RX0ж
                                        // intEn = DISABLE ,TX0 RX0жϽֹ
        break;
        
        default:
        break;
    }    
	__asm("EI");						// пж
}


//*********************************************************************
// 	: UART1_Int()
// 	: UART1ж/ֹ
// ֵ1	: - intEn     : ENABLE  
//                        : DISABLE ֹ
// ֵ2	: - trxSelect : TX
//                        : RX
//                        : TRX
// شֵ	: none
// ע		: ִкῪж(IMF)**
//*********************************************************************
void UART1_Int(uchar intEn, uchar trxSelect){
	__asm("DI");						// ֹпж

	switch(trxSelect){
	    case TX:						//  TX1ж/ֹ
            IER_UART1_TX1 = intEn;      // intEn = ENABLE  ,TX1ж
                                        // intEn = DISABLE ,TX1жϽֹ
        break;
    
    	case RX:						//  RX1ж/ֹ
            IER_UART1_RX1 = intEn;	    // intEn = ENABLE  ,RX1ж
                                        // intEn = DISABLE ,RX1жϽֹ
        break;
        
        case TRX:                       // TX1  RX1ж/ֹ
            IER_UART1_TX1 = IER_UART1_RX1 = intEn;
                                        // intEn = ENABLE  ,TX1 RX1ж
                                        // intEn = DISABLE ,TX1 RX1жϽֹ
        break;
        
        default:
        break;
    }    
	__asm("EI");						// пж
}


//*********************************************************************
// 	: UART2_Int()
// 	: UART2ж/ֹ
// ֵ1	: - intEn      : ENABLE  
//                         : DISABLE ֹ
// ֵ2	: - trxSelect  : TX
//                         : RX
//                         : TRX
// شֵ	: none
// ע		: ִкῪж(IMF)**
//*********************************************************************
void UART2_Int(uchar intEn, uchar trxSelect){

	__asm("DI");						// ֹпж

	switch(trxSelect){
	    case TX:						//  TX2ж/ֹ
            IER_UART2_TX2 = intEn;      // intEn = ENABLE  ,TX2ж
                                        // intEn = DISABLE ,TX2жϽֹ
        break;
    
    	case RX:						//  RX2ж/ֹ
            IER_UART2_RX2 = intEn;	    // intEn = ENABLE  ,RX2ж
                                        // intEn = DISABLE ,RX2жϽֹ
        break;
        
        case TRX:                       // TX2  RX2ж/ֹ
            IER_UART2_TX2 = IER_UART2_RX2 = intEn;
                                        // intEn = ENABLE  ,TX2 RX2ж
                                        // intEn = DISABLE ,TX2 RX2жϽֹ
        break;    
        
        default:
        break;
    }    
	__asm("EI");						// пж
}


//*********************************************************************
// 	: UART0_SetBaudRate()
// 	: BaudRateѡ趨
// ֵ	: - baudSel : Operat24M_Baud128000
//                        Operat24M_Baud115200
//                        Operat24M_Baud76800
//                        Operat24M_Baud62500
//                        Operat24M_Baud57600
//                        Operat24M_Baud38400
//                        Operat24M_Baud19200
//                        Operat24M_Baud9600
// شֵ	: none
//
// ע		: ϵbaudSelUART0Ƶ24MHz
//            ΪƵʣӦbaudSel趨SQ7515_UART.hͷ
//*********************************************************************

void UART0_SetBaudRate(uchar baudSel){

    // ѡRTʱ
    UART0CR2_RTSEL = RT;
        
    // ѡ(BaudRate)	    
    // ڸıUART0DR ǰ趨UART0CR1_RXE  UART0CR1_TXEΪ"0"
    UART0_Stop();						
    UART0DR = DR;
}
    
    
//*********************************************************************
// 	: UART1_SetBaudRate()
// 	: BaudRateѡ趨
// ֵ	: - baudSel : Operat24M_Baud128000
//                        Operat24M_Baud115200
//                        Operat24M_Baud76800
//                        Operat24M_Baud62500
//                        Operat24M_Baud57600
//                        Operat24M_Baud38400
//                        Operat24M_Baud19200
//                        Operat24M_Baud9600
// شֵ	: none
//
// ע		: ϵbaudSelڲƵ24MHz
//            ΪƵʣӦbaudSel趨SQ7515_UART.hͷ
//*********************************************************************

void UART1_SetBaudRate(uchar baudSel){

    // ѡRTʱ
    UART1CR2_RTSEL = RT;
        
    // ѡ(BaudRate)	    
    // ڸıUART1DR ǰ趨UART1CR1_RXE  UART1CR1_TXEΪ"0"
    UART1_Stop();						
    UART1DR = DR;
}


//*********************************************************************
// 	: UART2_SetBaudRate()
// 	: BaudRateѡ趨
// ֵ	: - baudSel : Operat24M_Baud128000
//                        Operat24M_Baud115200
//                        Operat24M_Baud76800
//                        Operat24M_Baud62500
//                        Operat24M_Baud57600
//                        Operat24M_Baud38400
//                        Operat24M_Baud19200
//                        Operat24M_Baud9600
// شֵ	: none
//
// ע		: ϵbaudSelڲƵ24MHz
//            ΪƵʣӦbaudSel趨SQ7515_UART.hͷ
//*********************************************************************

void UART2_SetBaudRate(uchar baudSel){

    // ѡRTʱ
    UART2CR2_RTSEL = RT;
        
    // ѡ(BaudRate)	    
    // ڸıUART2DR ǰ趨UART2CR1_RXE  UART2CR1_TXEΪ"0"
    UART2_Stop();						
    UART2DR = DR;
}



//*********************************************************************
// 	: UART0_Start()
// 	: UART0
// ֵ	: none
// شֵ	: none
// ע		:  TX0,RX0
//*********************************************************************
void UART0_Start(){
    UART0CR1_TXE = ENABLE;                   //  TX0 
	UART0CR1_RXE = ENABLE;                   //  RX0
}


//*********************************************************************
// 	: UART0_Stop()
// 	: ֹͣUART0
// ֵ	: none
// شֵ	: none
// ע		: ֹͣTX0,RX0
//*********************************************************************
void UART0_Stop(){
	UART0CR1_TXE = DISABLE;                   // ֹͣTX0
	UART0CR1_RXE = DISABLE;                   // ֹͣRX0
}

//*********************************************************************
// 	: UART1_Start()
// 	: UART1
// ֵ	: none
// شֵ	: none
// ע		:  TX1,RX1
//*********************************************************************
void UART1_Start(){
    UART1CR1_TXE = ENABLE;                   //  TX1 
	UART1CR1_RXE = ENABLE;                   //  RX1
}


//*********************************************************************
// 	: UART1_Stop()
// 	: ֹͣUART1
// ֵ	: none
// شֵ	: none
// ע		: ֹͣ TX1,RX1
//*********************************************************************
void UART1_Stop(){
	UART1CR1_TXE = DISABLE;                   // ֹͣTX1
	UART1CR1_RXE = DISABLE;                   // ֹͣRX1
}


//*********************************************************************
// 	: UART2_Start()
// 	: UART2
// ֵ	: none
// شֵ	: none
// ע		:  TX2,RX2
//*********************************************************************
void UART2_Start(){
    UART2CR1_TXE = ENABLE;                   //  TX2 
	UART2CR1_RXE = ENABLE;                   //  RX2
}

//*********************************************************************
// 	: UART2_Stop()
// 	: ֹͣUART2
// ֵ	: none
// شֵ	: none
// ע		: ֹͣ TX2,RX2
//*********************************************************************
void UART2_Stop(){
	UART2CR1_TXE = DISABLE;                   // ֹͣTX2
	UART2CR1_RXE = DISABLE;                   // ֹͣRX2
}

//*********************************************************************
// 	: UART0_TX_OneByte()
// 	: UART0 TX䵥һֽ (1 byte)
// ֵ	: data: TX͵
// شֵ	: none
// ע		: *UART0
//*********************************************************************
void UART0_TX_OneByte(uchar data){
	
	while(UART0SR_TBFL == 1){			// ȴͻΪգٴдҪ֮
		CLR_WDT;						// Źʱ (ι)
    }

	TD0BUF = data;						// дҪ֮
    
	while(UART0SR_TBSY == 1){			// 1:䷢ , 0:ǰȴ͹
        CLR_WDT;						// Źʱ (ι)
    }
}


//*********************************************************************
// 	: UART0_RX_OneByte()
// 	: UART0 RXյһֽ (1 byte)
// ֵ	: none
// شֵ	: RXҪյ
// ע		: *UART0        
//*********************************************************************
uchar UART0_RX_OneByte(){
	
    while(!UART0SR_RBFL);               // ȴUART0 RD0BUFյ
	return RD0BUF;                      // յRD0BUF

}



//*********************************************************************
// 	: UART1_TX_OneByte()
// 	: UART1 TX䵥һֽ (1 byte)
// ֵ	: data: TX͵
// شֵ	: none
// ע		: *UART1
//*********************************************************************
void UART1_TX_OneByte(uchar data){

	while(UART1SR_TBFL == 1){			 // ȴͻΪգٴдҪ֮
		CLR_WDT;						 // Źʱ (ι)
    }
	TD1BUF = data;						 // дҪ֮
    
	while(UART1SR_TBSY ==1){			 // 1:䷢ , 0:ǰȴ͹
        CLR_WDT;						 // Źʱ (ι)
    }
}


//*********************************************************************
// 	: UART1_RX_OneByte()
// 	: UART1 RXյһֽ (1 byte)
// ֵ	: none
// شֵ	: RXҪյ
// ע		: *UART1
//*********************************************************************
uchar UART1_RX_OneByte(){
    
    while(!UART1SR_RBFL);               // ȴUART1 RD1BUFյ
	return RD1BUF;                      // յRD1BUF

}


//*********************************************************************
// 	: UART2_TX_OneByte()
// 	: UART2 TX䵥һֽ (1 byte)
// ֵ	: data: TX͵
// شֵ	: none
// ע		: UART2
//*********************************************************************
void UART2_TX_OneByte(uchar data){

	while(UART2SR_TBFL == 1){			 // ȴͻΪգٴдҪ֮      
		CLR_WDT;                     	 // Źʱ (ι)
    }
	TD2BUF = data;						 // дҪ֮
    
	while(UART2SR_TBSY ==1){			 // 1:䷢ , 0:ǰȴ͹
        CLR_WDT;                         // Źʱ (ι)
    }
}


//*********************************************************************
// 	: UART2_RX_OneByte()
// 	: UART2 RXշһֽ (1 byte)
// ֵ	: none
// شֵ	: RXҪյ
// ע		: *UART2
//*********************************************************************
uchar UART2_RX_OneByte(){

    while(!UART2SR_RBFL);               // ȴUART2 RD2BUFյ
	rbuf = RD2BUF;                       // յRD2BUF
	
    while(UART1SR_RBSY ==1){		     // 1:䷢ , 0:ǰȴ͹
            CLR_WDT;                     // Źʱ (ι)
    }
	return rbuf;
	
}



//*********************************************************************
// 	: UART_ReadState()
// 	: ȡش UART ״̬
// ֵ	: - uartSel: UART0, UART1, UART2
// شֵ	: UART ״̬
// ע		: UARTѡ       
//*********************************************************************

uchar UART_ReadState(uchar uartSel){
	if(uartSel == UART0){
		return UART0SR;
	}
	else if(uartSel == UART1){
		return UART1SR;
	}
	else if(uartSel == UART2){
		return UART2SR;
	}
	else{
		return 0;
    }
}


//*********************************************************************
// 	: UART_TX_OneByte()
// 	: TX䵥һֽ (1 byte)
// ֵ	: - uartSel: UART0, UART1, UART2
//            - data   : TX͵
// شֵ	: none
// ע		: UARTѡ        
//*********************************************************************
void UART_TX_OneByte(uchar uartSel, uchar data){
	
    if(uartSel == UART0){
        while(UART0SR_TBFL){            // ȴͻΪգٴдҪ֮
            CLR_WDT;                    // Źʱ (ι)
        }

        TD0BUF = data;					// дҪ֮

		while(UART0SR_TBSY){
            CLR_WDT;                    // Źʱ (ι)
        }	
    }	
    else if(uartSel == UART1){
        while(UART1SR_TBFL){            // ȴͻΪգٴдҪ֮
            CLR_WDT;                    // Źʱ (ι)
        }

		TD1BUF = data;                  // дҪ֮

		while(UART1SR_TBSY){
		    CLR_WDT;                    // Źʱ (ι)
        }
	
    }
	else if(uartSel == UART2){
		while(UART2SR_TBFL){            // ȴͻΪգٴдҪ֮
            CLR_WDT;                    // Źʱ (ι)
		}

		TD2BUF = data;                  // дҪ֮

		while(UART2SR_TBSY){
		    CLR_WDT;                    // Źʱ (ι)
        }
    }

}

//*********************************************************************
// 	: UART_RX_OneByte()
// 	: RXյһֽ (1 byte)
// ֵ	: - uartSel: UART0, UART1, UART2
// شֵ	: RXҪյ
// ע		: UARTѡ           
//*********************************************************************
uchar UART_RX_OneByte(uchar uartSel){

    if(uartSel == UART0){
        while(!UART0SR_RBFL);           // ȴUART0 RD0BUFյ
        return RD0BUF;                  // յRD0BUF
    }
    else if(uartSel == UART1){
        while(!UART1SR_RBFL);           // ȴUART1 RD1BUFյ
        return RD1BUF;                  // յRD1BUF
    }
    else if(uartSel == UART2){
        while(!UART2SR_RBFL);           // ȴUART2 RD2BUFյ
        return RD2BUF;                  // յRD2BUF
	}
	else{
	    return 0;
    }
}


//*********************************************************************
// 	: UART_Send_Bytes()
// 	: TX䲻ֻ1ֽ (more Bytes)
// ֵ	: - uartSel: UART0, UART1, UART2
//            - sentBuf: ͵ֽȷsentBuf[]
//            - len    : ֽڳȴС
// شֵ	: none
//
// ע		: *Ҫϲֻ1Byteʱʹãʹ߿趨ֽڳȴС
//
// 		: 12ֽڣҴ͵ֽȷbuf[]ڣ
//            sentBuf[0]~sentBuf[11]
//
//            UART_Send_Bytes(UART1,sentBuf, 12);          
//*********************************************************************
void UART_Send_Bytes(uchar uartSel, uchar* sentBuf, uchar len){

	uchar i;

    for(i=0; i<len; i++){
        if(uartSel == UART0){
            while(UART0SR_TBFL){
                CLR_WDT;                // Źʱ (ι)
            }

            TD0BUF = sentBuf[i];        // ҪͳY

            while(UART0SR_TBSY){
                CLR_WDT;                // Źʱ (ι)
            }
        }		
		else if(uartSel == UART1){
            while(UART1SR_TBFL){
                CLR_WDT;                // Źʱ (ι)
            }

            TD1BUF = sentBuf[i];        // ҪͳY

            while(UART1SR_TBSY){
                CLR_WDT;                // Źʱ (ι)
            }
        }
        else if(uartSel == UART2){
            while(UART2SR_TBFL){
                CLR_WDT;                // Źʱ (ι)
            }

            TD2BUF = sentBuf[i];        // ҪͳY

            while(UART2SR_TBSY){
                CLR_WDT;                // Źʱ (ι)
            }
        }
    }
}

//*********************************************************************
// 	: UART_Nibble2Ascii()
// 	: λԪתAscii
// ע		:           
//*********************************************************************
uchar UART_Nibble2Ascii(uchar anibble){
    uchar	ascii_out = anibble;

    if(anibble > 9){                    // If req ASCII A-F then add 7(hex)	
        ascii_out = ascii_out + 0x07;
    }

    // Add offset to convert to Ascii
    ascii_out = ascii_out + 0x30;

    return(ascii_out);
}


//*********************************************************************
// 	: UART_PutByte()
// 	: õ high nibbleת ASCII TXͣ
//            õ low nibbleת ASCII TX
// ע		: 
//*********************************************************************
void UART_PutByte(uchar uartSel,uchar abyte){
    uchar  temp1 = 0, temp2 = 0;	

    temp1 = (abyte >> 4) & 0x0F;        // õ high nibble
    temp2 = UART_Nibble2Ascii(temp1);   // high nibbleת ASCII
    UART_TX_OneByte(uartSel,temp2);     // 

    temp1 = abyte & 0x0F;               // õ low nibble
    temp2 = UART_Nibble2Ascii(temp1);   // low nibbleת ASCII
    UART_TX_OneByte(uartSel,temp2);     // 
}



//*********************************************************************
// 	: UART_PutDecNumber()
// 	: 
// ע		: ***Input value range : 0~9999 
//*********************************************************************
void UART_PutDecNumber(uint value){
    uchar print_buf[4];
	 
    if(value > 9999){
        value = 9999;
    }		
	
    print_buf[0] = ((value%10000)/1000)+'0';
    print_buf[1] = ((value%1000)/100)+'0';
    print_buf[2] = ((value%100)/10)+'0';
    print_buf[3] = ((value%10))+'0';
     
	UART_Send_Bytes(UART1,print_buf,4);
}

//*********************************************************************
// 	: UART_PutCrlf()
// 	: ͶԪ
// ע		: 
//*********************************************************************
void UART_PutCrlf(void){

/*	
    UART_TX_OneByte(UART0,'\r');
    UART_TX_OneByte(UART0,'\n');
*/	

    UART_TX_OneByte(UART1,'\r');
    UART_TX_OneByte(UART1,'\n');

/*	
    UART_TX_OneByte(UART2,'\r');
    UART_TX_OneByte(UART2,'\n');
*/	
	
}


//*********************************************************************
// 	: UART_SendCString()
// 	: ִ
// ֵ	: һִ
// شֵ	: none
// ע		: 
// 		: Hello World!
//            UART_SendCString("Hello World!")
//*********************************************************************
void UART_SendCString(const char *pstr){

    while(*pstr != 0){	
        if(*pstr == '\n'){
            UART_PutCrlf();
        }
        else{		
            //UART_TX_OneByte(UART0,*pstr);
            UART_TX_OneByte(UART1,*pstr);
            //UART_TX_OneByte(UART2,*pstr);
        }

		pstr++;
	}
}


//*********************************************************************
// 	: Check_Recive_Data_LED()
// 	: ȶյϣȷӦLED
// ֵ	: none
// شֵ	: none
// ע		:
//*********************************************************************
void Check_Recive_Data_LED(void)
{
    uchar i,check_result;
    check_result = 0;
 
    if(reciveBuf[0] == 0x55){					
        LED1_to_LED3_turn_off;
        LED1_out = 0;                   // 0x55LED1(P2.0)
    }
    else if(reciveBuf[0] == 0xAA){
        LED1_to_LED3_turn_off;				
        LED2_out = 0;                   // 0xAALED2(P2.1)
    }
    else if(reciveBuf[11] == 0xA5){	
        LED1_to_LED3_turn_off;

        // ֮reciveBuf[]봫֮sentBuf[]һһȶ
        for (i=0; i<12; i++){           // ȶ12BytesData
            if(reciveBuf[i] == sentBuf[i]){ 
                check_result++;
            }

            if(check_result==12){
                LED3_out = 0;           // ȷLED3(P2.2)    
            }
		}
    }


}



//*********************************************************************
// 	: __interrupt IntRX0()
// 	: RX0 жӳ
// ע		:
//*********************************************************************
void __interrupt IntRX0(void){
    __asm("NOP");                       // ָ
}


//*********************************************************************
// 	: __interrupt IntRX1()
// 	: RX1 жӳ
// ע		: ȡϣյϷϴϣӦLED
//*********************************************************************
void __interrupt IntRX1(void){
    __asm("NOP");                       // ָ
	
    RX1_Int_Flag = 1;                   // IntRX1жϷΪ1
   
    reciveBuf[rx1_int_count] = RD1BUF;  // յ

    rx1_int_count++ ;

}


//*********************************************************************
// 	: __interrupt IntRX2()
// 	: RX2 жӳ
// ע		:
//*********************************************************************
void __interrupt IntRX2(void){
    __asm("NOP");                       // ָ
}


//*********************************************************************
// 	: __interrupt IntTX0()
// 	: TX0 жӳ
// ע		:
//*********************************************************************
void __interrupt IntTX0(void){
    __asm("NOP");                       // ָ
}

//*********************************************************************
// 	: __interrupt IntTX1()
// 	: TX1 жӳ
// ע		:
//*********************************************************************
void __interrupt IntTX1(void){
    __asm("NOP");                       // ָ
}

//*********************************************************************
// 	: __interrupt IntTX2()
// 	: TX2 жӳ
// ע		:
//*********************************************************************
void __interrupt IntTX2(void){
    __asm("NOP");                       // ָ
}

/* ------------------------- ļβ ---------------------------- */
